#!/bin/bash

# 定义递归函数factorial来计算阶乘
factorial() {
    local n=$1
    # 递归基准情况：0的阶乘为1
    if [ $n -eq 0 ]; then
        echo 1
    else
        # 递归步骤：n的阶乘为n乘以(n-1)的阶乘
        local prev_factorial=$(factorial $((n - 1)))
        echo $((n * prev_factorial))
    fi
}

# 从命令行读取一个数字
read -p "Enter a number to calculate its factorial: " num

# 检查输入是否为非负整数
if ! [[ "$num" =~ ^[0-9]+$ ]]; then
    echo "Error: Input is not a non-negative integer."
    exit 1
fi

# 调用函数并打印结果
result=$(factorial $num)
echo "The factorial of $num is:$result"
